package parkup.configs.token;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import javax.transaction.Transactional;
import java.time.LocalDateTime;
import java.util.Optional;

@Repository
public interface ConfirmationTokenRepositoryW extends JpaRepository<ConfirmationTokenW,Integer> {

    Optional<ConfirmationTokenW> findByToken(String token);

    void deleteByVraboten_VrabotenId(int vraboten_id);

    @Transactional
    @Modifying
    @Query("UPDATE ConfirmationTokenW c " +
            "SET c.confirmedAt = ?2 " +
            "WHERE c.token = ?1")
    int updateConfirmedAt(String token, LocalDateTime confirmedAt);
}
